<?php

declare(strict_types=1);

namespace IQDEV\Packages\DoctrineHttpFilter\Filter;

use Doctrine\ORM\QueryBuilder;
use IQDEV\Packages\DoctrineHttpFilter\Exception\FilterParameterValueIsNullException;
use IQDEV\Packages\DoctrineHttpFilter\HttpFilter;

final class In extends HttpFilter
{
    /** @throws FilterParameterValueIsNullException */
    public function addToQuery(QueryBuilder $queryBuilder): QueryBuilder
    {
        if ($this->getHttpValue() === null || ! is_array($this->getHttpValue())) {
            throw new FilterParameterValueIsNullException($this->field);
        }

        $values = array_map(fn($value) => '\'' . $value . '\'', $this->getHttpValue());
        $stringValues = implode(',', $values);

        $queryBuilder->where(
            $this->getColumn() . ' IN (' . $stringValues . ')',
        );

        return $queryBuilder;
    }
}
